#=========================================================================
# R-file evaluating the duration of bilateral trade relationships      
# author: Wolfgang Hess
# ========================================================================

file_names<-as.list(dir(pattern="*s7.RData"))
lapply(file_names,load,.GlobalEnv)
coefmodel29<-c(.2296895,-.0424059,-.0434424,-.1893768,-.1512861,.8722931,.3240901,.4089679,.7060178)
coef.mat1<-cbind(coefmodel00[16:24],coefmodel10[16:24],coefmodel29,coefmodelp[16:24])
coef.mat1<-round(coef.mat1,digits=4)
coef.mat1
ll1<--0.5*cbind(devmodel00,devmodel10,2*403801,devmodelp)
file_names<-as.list(dir(pattern="*s4.RData"))
lapply(file_names,load,.GlobalEnv)
coef.mat2<-cbind(coefmodel00[16:24],coefmodel10[16:24],coefmodel44[16:24],coefmodelp[16:24])
coef.mat2<-round(coef.mat2,digits=4)
coef.mat2
cbind(coef.mat1,coef.mat2)
round(cbind(ll1,-0.5*cbind(devmodel00,devmodel10,devmodel44,devmodelp)),digits=0)
cbind(coefmodel00[25],coefmodel10[25],coefmodel44[25],coefmodelp[25])
sigma<-cbind(coefmodel00[25],coefmodel10[25],coefmodel44[25],coefmodelp[25])
linkvar<-cbind(pi^2/6,pi^2/3,trigamma(1)+trigamma(1/4.4),1)
round(sigma^2/(linkvar+sigma^2),digits=4)

#get transport-ex.rate coefficient ratios from the 4 frailty models (Table4, row 1)
coefmodel00["transport"]/coefmodel00["pctrer_relative"]
coefmodel10["transport"]/coefmodel10["pctrer_relative"]
coefmodel44["transport"]/coefmodel44["pctrer_relative"]
coefmodelp["transport"]/coefmodelp["pctrer_relative"]

# #get standardized coefficients from the 4 frailty models
# linkvar.mat<-t(matrix(rep(linkvar,9),ncol=9))
# coef.mat2/sqrt(linkvar.mat) #version 1
# totvar<-linkvar+(sigma/linkvar)^2
# totvar.mat<-t(matrix(rep(totvar,9),ncol=9))
# coef.mat2/sqrt(totvar.mat) #version 2

# #get standardized coefficients from the 4 non-frailty models
# linkvar.mat<-t(matrix(rep(linkvar,9),ncol=9))
# linkvar.mat[,3]<-trigamma(1)+trigamma(1/4.2909)
# round(coef.mat1/sqrt(linkvar.mat),digits=4)
# standard<-abs(coef.mat1/sqrt(linkvar.mat))
# as.vector(standard[,1]>standard[,2])
# as.vector(standard[,1]>standard[,4])
# as.vector(standard[,2]>standard[,4])
# 
# #yet another representation
# coef.mat2/cbind(coef.mat2[,3],coef.mat2[,3],coef.mat2[,3],coef.mat2[,3])



library(foreign)
dat<-read.dta("calcprobs.dta")
str(dat)

xbcloglog<-mean(cbind(1,as.matrix(dat[,c(4:10,12:13)]))%*%coefmodel00[c(1,16:24)])+c(0,coefmodel00[2:15],coefmodel00[15])
phatcloglog<-1-exp(-exp(xbcloglog))
xblogit<-mean(cbind(1,as.matrix(dat[,c(4:10,12:13)]))%*%coefmodel10[c(1,16:24)])+c(0,coefmodel10[2:15],coefmodel10[15])
phatlogit<-1/(1+exp(-xblogit))
xbburr<-mean(cbind(1,as.matrix(dat[,c(4:10,12:13)]))%*%coefmodel44[c(1,16:24)])+c(0,coefmodel44[2:15],coefmodel44[15])
phatburr<-1-(1+4.4/exp(-xbburr))^(-1/4.4)
xbprobit<-mean(cbind(1,as.matrix(dat[,c(4:10,12:13)]))%*%coefmodelp[c(1,16:24)])+c(0,coefmodelp[2:15],coefmodelp[15])
phatprobit<-pnorm(xbprobit)


# #d log(h)/d x=beta_x*h'/h
# round(coefmodel00["transport"]*exp(xbcloglog)*exp(-exp(xbcloglog))/phatcloglog,digits=3)
# round(coefmodel10["transport"]*exp(xblogit)*(1+exp(xblogit))^(-2)/phatlogit,digits=3)
# round(coefmodel44["transport"]*exp(xbburr)*(1+4.4*exp(xbburr))^(-1/4.4-1)/phatburr,digits=3)
# round(coefmodelp["transport"]*dnorm(xbprobit)/phatprobit,digits=3)
# round(coefmodel00["pctrer_relative"]*exp(xbcloglog)*exp(-exp(xbcloglog))/phatcloglog,digits=3)
# round(coefmodel10["pctrer_relative"]*exp(xblogit)*(1+exp(xblogit))^(-2)/phatlogit,digits=3)
# round(coefmodel44["pctrer_relative"]*exp(xbburr)*(1+4.4*exp(xbburr))^(-1/4.4-1)/phatburr,digits=3)
# round(coefmodelp["pctrer_relative"]*dnorm(xbprobit)/phatprobit,digits=3)

#hazard ratios: h(xb+beta_x*1)/h(xb) -> Table 4 (rows 2-5)
round((1-exp(-exp(xbcloglog+coefmodel00["transport"])))/phatcloglog,digits=3)
round((1/(1+exp(-(xblogit+coefmodel10["transport"]))))/phatlogit,digits=3)
round((1-(1+4.4*exp(xbburr+coefmodel44["transport"]))^(-1/4.4))/phatburr,digits=3)
round(pnorm(xbprobit+coefmodelp["transport"])/phatprobit,digits=3)
round((1-exp(-exp(xbcloglog+coefmodel00["pctrer_relative"])))/phatcloglog,digits=3)
round((1/(1+exp(-(xblogit+coefmodel10["pctrer_relative"]))))/phatlogit,digits=3)
round((1-(1+4.4*exp(xbburr+coefmodel44["pctrer_relative"]))^(-1/4.4))/phatburr,digits=3)
round(pnorm(xbprobit+coefmodelp["pctrer_relative"])/phatprobit,digits=3)



